#include <avr/io.h>

#include "./apps.h"
#include "../menu/menu.h"
#include "./realtimeclock.h"
#include "../types/ranged.h"

void IdleApplication(uint8_t Event){
    static t_ActiveApplication LastActiveApplication;
    static t_ranged_uint8_t ChangeDisplay = {
        .value = 0,
        .bottom = 0,
        .top = 10,
    };
    t_datetime adatetime = RealTime_GetDateTime();
    switch( Event){
        case UP:
        case DOWN:
        case LEFT:
        case RIGHT:
        case OK:{
            //hack for redraw
            LastActiveApplication(UP);
            LastActiveApplication(DOWN);
            ActiveApplication = LastActiveApplication;
            return;
        }
        break;
        case TICK:{
            DisplayDateAt(0,0, &adatetime, 1);
            DisplayTimeAt(0,1, &adatetime);
            rangedInc_uint8_t(&ChangeDisplay);
        }
        break;
        case NO_KEY:{
            Clear();
            ChangeDisplay.value = 0;
            LastActiveApplication = ActiveApplication;
            ActiveApplication = IdleApplication;
        }
        break;
        case ONE_MINUTE_TICK:{
        updateChannels(adatetime);
        return;
        }
        break;
    }
    if(ChangeDisplay.value < 5){
        PrintStringPos(0,2, "Heizung akt.:");
        PrintStringPos(0,3, SwitchpointToASCII(&Current[0].value));
        PrintStringPos(0,4, "danach: ");
        PrintString(daynames[Next[0].valid_on_dow]);
        PrintStringPos(0,5, SwitchpointToASCII(&Next[0].value));
    }
    if(ChangeDisplay.value > 5){
        PrintStringPos(0,2, "Warmw. akt.: ");
        PrintStringPos(0,3, SwitchpointToASCII(&Current[1].value));
        PrintStringPos(0,4, "danach: ");
        PrintString(daynames[Next[1].valid_on_dow]);
        PrintStringPos(0,5, SwitchpointToASCII(&Next[1].value));
    }
}
