#include <avr/io.h>
#include <stdbool.h>
#include <avr/interrupt.h>
#include <stdio.h>
#include <stdlib.h>


#include "backlight.h"

t_ranged_uint8_t volatile BackLightPWM = {
    .value = BackLightPWMStart,
    .top = BackLightPWMStart,
    .bottom = 0
};

void InitBackLight(){
    //Timer0-->Enable OutputComparePin, FastPWM noninverted
    TCCR0A = (1 << COM0A1) | (1 << WGM00) | (1 << WGM01) ;
    //Interrupt on Overflow
    TIMSK0 = (1 << TOIE0);
    OCR0A = (16 * BackLightPWM.value)-1;
    //Prescaler 256 ca 64Hz
    TCCR0B = (1 << CS02) ;
}


ISR(TIMER0_OVF_vect){
    static uint8_t PWM = BackLightPWMStart;
    if (BackLightPWM.value == 0){
        TCCR0A &= ~(1<<COM0A1);
        OCR0A = 0x00;
    }
    else{
        if (PWM == BackLightPWM.value) return;
        OCR0A = (16 * BackLightPWM.value) -1;
        TCCR0A |= (1<<COM0A1);
    }
    PWM = BackLightPWM.value;
}
